# Gt Ruby SDK3

ruby gem [geetest(0.1.6)](https://rubygems.org/gems/geetest) already deprecated.

[Geetest SDK3](http://www.geetest.com/install/sections/idx-server-sdk.html#python) logic copy from [gt-python-sdk](https://github.com/GeeTeam/gt-python-sdk)

## Usage

```
gem 'geetest3'
```

```
require 'gestest'

# register when page load done
get '/popup/register' do
  user_id = nil # set here if can get user_id
  gt = Geetest::SDK3.new(captcha_id, private_key)
  status = gt.pre_process(user_id)
  session[gt.session_key] = status
  session['token'] = user_id || params[:avoid_cache_token]
  gt.response_str
end

# validate geetest before submit
post '/:type/validate' do
  gt = Geetest::SDK3.new(captcha_id, private_key)
  challenge = params[gt.fn_challenge]
  validate = params[gt.fn_validate]
  seccode = params[gt.fn_seccode]

  if session[gt.session_key]
    result = gt.success_validate(challenge, validate, seccode, session['token'])
  else
    result = gt.failback_validate(challenge, validate, seccode)
  end

  { status: (result ? 'login successfully' : 'login falied') }.to_json
end
```

## Example

```
$ git clone git@github.com:jay16/gt-ruby-sdk3.git
$ cd gt-ruby-sdk3/example
$ gem install sinatra
$ ruby sinatra.rb
```

browser visit localhost:4567 view demo.
